var $ = jQuery;
$(function() {
	var SelectDepartment = $('select.SelectDepartment');
	var InputNameFilter = $('input.InputTeacherName');
	var SelectFaculty = $('select.SelectFaculty');

	var teacherPrototype = $($.parseHTML(
								'<div class="Teacher" id="0">\
									<div class="Name"></div>\
									<button class="Action"></button>\
								</div>'
							));

// Добавить преподавателя
function AddTeacher(ID, Name, Action){
	var cell = teacherPrototype.clone();
	cell.prop('id', ID);
	cell.find('div.Name').html(Name);
	var temp = cell.find('button.Action');
	temp.addClass('Action_'+Action+'Teacher');

	if (Action == 'Unbind') 
		temp.html('Отсоединить');
	else if (Action == 'Bind')
		temp.html('Присоединить');
	return cell;
}


// Поиск преподавателей
function CallSearchTeachers(){
	var Name = [];
	Name = InputNameFilter.val().split(' ');
	$.post(
		URLdir + 'handler/map/SearchTeachers',
		{
			'FacultyID': SelectFaculty.val(),
			'DepartmentID': SelectDepartment.val(),
			'Last': Name[0],
			'First': Name[1],
			'Second': Name[2],
			'DisciplineID': DisciplineID
		},
		function(data){
			var SearchResult = $.parseJSON(data);
			var SearchResultDIV = $('.SearchResult');
			var i = 0;
			if (SearchResult != null && SearchResult != undefined) {
				SearchResultDIV.html('');
				for(i in SearchResult) {
					var Name = SearchResult[i].TeacherLast + ' ' + SearchResult[i].TeacherFirst + ' ' + SearchResult[i].TeacherSecond;
					SearchResultDIV.append(AddTeacher(SearchResult[i].TeacherID, Name, 'Bind'));
				}
			}
			if (i<= 0) SearchResultDIV.html('<p class="notification">Нет результатов... Возможно, преподаватели, соответствующие критериям поиска, уже прикреплены.</p>');
		}
	);
}

// Выборка факультета
SelectFaculty.change(function(){
	SelectDepartment.prop('disabled',true);
	InputNameFilter.prop('disabled',true);
	$.post(
		URLdir + 'handler/map/GetDepartments',
		{
			'FacultyID': $(this).val()
		},
		function(Dep){
			var Dep = $.parseJSON(Dep);
			var i = 0;
			if (Dep != null && Dep != undefined) {
				
				SelectDepartment.html('<option value="0">Выберите кафедру (не обязательно)</option>');
				for (i in Dep) {
					SelectDepartment.append('<option value="'+ Dep[i].ID +'">'+ Dep[i].Name +'</option>');
				}
				if (i <= 0)
					SelectDepartment.html('<option value="0">Нет кафедр</option>');		
			}
			SelectDepartment.removeAttr('disabled');
			InputNameFilter.removeAttr('disabled');	
		}
	);
});

SelectDepartment.change(function(){
	CallSearchTeachers();
});
InputNameFilter.focusout(function(){
	CallSearchTeachers();
});
InputNameFilter.keydown(function(e){
	if(e.keyCode==13){
		$(this).focusout('focusout');
		$(this).blur();
	}
});

// $('.SelectFaculty').focusout(function(){
// 	$('.SelectFaculty').trigger('change');
// });
// $('.SelectDepartment').focusout(function(){
// 	$('.SelectDepartment').trigger('change');
// });

// Конец поиска преподавателей

// Отсоединить преподавателя
$('.TeachersList').on('click', 'button.Action_UnbindTeacher', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/UnbindTeacher',
		{
			'BindingTeacher': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				EventInspector_ShowMsg('Преподаватель отсоединен', 'success');
				thisObj
					.parent()
					.remove();
			}
			else {
				EventInspector_ShowMsg('Ошибка при отсоединение преподавателя', 'error');
				thisObj.removeAttr('disabled');
			}
		}
	);
});

// Присоединить преподавателя
$('.TeachersList').on('click', 'button.Action_BindTeacher', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	var Name = $(this).siblings('.Name').text();
	$.post(
		URLdir + 'handler/map/BindTeacher',
		{
			'BindingTeacher': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				$('.BindTeachersList').append(AddTeacher(ID, Name, 'Unbind'));
				EventInspector_ShowMsg('Преподаватель прикреплен', 'success');
				thisObj
					.parent()
					.remove();
			}
			else {
				EventInspector_ShowMsg('Ошибка при прикрепление преподавателя', 'error');
				thisObj.removeAttr('disabled');
			}
		}
	);
});

});